#!/usr/bin/env php
<?php
/**
 * list_template.cli.php
 * Code by Strangecode :: www.strangecode.com :: This document contains copyrighted information
 */


// Get module maker configuration.
require_once dirname(__FILE__) . '/_config.inc.php';

$op = null;
$valid_ops = array('headerrows', 'listrows');

// Test arguments.
if ($_SERVER['argc'] == 3) {
    $db_tbl = $_SERVER['argv'][2];
} else if ($_SERVER['argc'] == 4) {
    $db_tbl = $_SERVER['argv'][2];
    $op = $_SERVER['argv'][3];
} else {
    die(basename($_SERVER['argv'][0]) . " Warning: You must specify a DB table as the second argument.\n");
}

// Get DB tables.
$qid = dbQuery("SHOW TABLES");
while (list($row) = mysql_fetch_row($qid)) {
    $tables[] = $row;
}

// Make sure requested table is in database.
if (!in_array($db_tbl, $tables)) {
    die(basename($_SERVER['argv'][0]) . " Warning: $db_tbl does not exist in database $CFG->database. Please select one of: \n\n" . join("\n", $tables) . "\n\n");
}

// Make sure op is valid.
if (isset($op) && !in_array($op, $valid_ops)) {
    die(basename($_SERVER['argv'][0]) . " Warning: Operation '$op' is not something I know how to do Please select one of: " . join(", ", $valid_ops) . "\n");
}

// Get DB table column info.
$qid = dbQuery("DESCRIBE " . mysql_real_escape_string($db_tbl));
while ($row = mysql_fetch_row($qid)) {
    $cols[] = $row;
}

// Loop through columns
if (is_array($cols) && !empty($cols)) {
    foreach ($cols as $col) {
        
        // Human readable.
        $field = $col[0];
        $title = ucfirst(str_replace('_', ' ', $field));
        $type = preg_replace('/^(\w+).*$/', '\\1', $col[1]);
        
        // Get primary key.
        if ('PRI' == $col[3]) {
            $primary_key = $field;
        }
        
        // Column headers.
        $headers[$field] = $title;
        
        // Column data.
        if (preg_match("/enum\('true'\)/", $col[1])) {
            $listrows[] = "<\x3fphp echo (!empty(\$list[\$i]['$field'])) ? '&bull;' : ''; \x3f>";
        } else if (
            'tinytext' == $type ||
            'text' == $type ||
            'mediumtext' == $type ||
            'longtext' == $type ||
            'tinyblob' == $type ||
            'blob' == $type ||
            'mediumblob' == $type ||
            'longblob' == $type
        ) {
            $listrows[] = "<\x3fphp echo strlen(\$list[\$i]['$field'])<50 \x3f oTxt(\$list[\$i]['$field'], true) : oTxt(trim(substr(\$list[\$i]['$field'], 0, 50)) . '...'); \x3f>";
        } else if (preg_match('/.*(begin|start).*date.*/i', $field)) {
            $listrows[] = "<\x3fphp echo '0000-00-00' == \$list[\$i]['$field'] ? '' : date(\$CFG->date_format, strtotime(\$list[\$i]['$field'])); \x3f>";
        } else if (preg_match('/.*(end|expire).*date.*/i', $field)) {
            $listrows[] = "<\x3fphp echo '9999-12-31' == \$list[\$i]['$field'] ? '' : date(\$CFG->date_format, strtotime(\$list[\$i]['$field'])); \x3f>";
        } else if (preg_match('/datetime/i', $type)) {
            $listrows[] = "<\x3fphp echo '0000-00-00 00:00:00' == \$list[\$i]['$field'] ? '' : date(\$CFG->date_format, strtotime(\$list[\$i]['$field'])); \x3f>";
        } else if (preg_match('/date/i', $type)) {
            $listrows[] = "<\x3fphp echo '0000-00-00' == \$list[\$i]['$field'] ? '' : date(\$CFG->date_format, strtotime(\$list[\$i]['$field'])); \x3f>";
        } else if (preg_match('/(amount|_rate)/i', $field)) {
            $listrows[] = "<\x3fphp printf('$%01.2f', \$list[\$i]['$field']); \x3f>";
        } else if (preg_match('/(added_by_admin_id)/i', $field)) {
            $listrows[] = "<\x3fphp echo oTxt(\$list[\$i]['added_admin_username']); \x3f>";
        } else if (preg_match('/(modified_by_admin_id)/i', $field)) {
            $listrows[] = "<\x3fphp echo oTxt(\$list[\$i]['modified_admin_username']); \x3f>";
        } else if ('rank' == $field) {
            $listrows[] = "<input type=\"text\" name=\"rank[<\x3fphp echo \$list[\$i]['$primary_key']; \x3f>]\" value=\"<\x3fphp echo \$list[\$i]['rank']; \x3f>\" size=\"5\" />";
        } else {
            $listrows[] = "<\x3fphp echo oTxt(\$list[\$i]['$field'], true); \x3f>";
        }
    }
} else {
    die(basename($_SERVER['argv'][0]) . " Warning: $db_tbl does not have any columns.\n");
}

// Print the template out.
echo isset($op) ? '' : <<<E_O_F

<\x3fphp include 'form_error_header.ihtml'; \x3f>
<form action="<\x3fphp echo oTxt(\$_SERVER['PHP_SELF']); \x3f>" method="get">
<\x3fphp printHiddenSession(false); \x3f>

<div id="commandbox">
    <span class="nowrap commandtext"><a href="<\x3fphp echo ohref(\$_SERVER['PHP_SELF'] . '?op=add'); \x3f>"><\x3fphp echo _("Add <##>"); \x3f></a></span>
    <br />
    
    <input type="text" class="forminputtext" size="20" name="search_query" value="<\x3fphp echo getFormData('search_query'); \x3f>" title="<\x3fphp echo oTxt(_("Fields searched: <##>.")); \x3f>" />
    <select name="filter_<##>">
        <\x3fphp // printSelectForm('<##>_tbl', "CONCAT(<##>_id, '&mdash;', city, '&mdash;', title)", '<##>_id', getFormData('filter_<##>'), array('Any <##>'), 'ORDER BY <##> ASC'); \x3f>
    </select>
    <input type="submit" name="list" value="<\x3fphp echo _("Search"); \x3f>" />
</div>

<?php include 'adm_list_info.ihtml'; \x3f>

<table class="list">
    <tr>
        <th>&nbsp;</th>
        <th>&nbsp;</th>

E_O_F;


// Print header rows.
if (!isset($op) || 'headerrows' == $op) {
    foreach ($headers as $field=>$title) {
        if ($field == $primary_key) {
            echo "        <th><\x3fphp echo \$so->printSortHeader('$db_tbl.$field', _(\"ID\"), 'ASC'); \x3f></th>\n";
        } else {
            echo "        <th><\x3fphp echo \$so->printSortHeader('$db_tbl.$field', _(\"$title\"), 'ASC'); \x3f></th>\n";
        }
    }
}

echo isset($op) ? '' : <<<E_O_F
        <th>&nbsp;</th>
    </tr>
    <\x3fphp for (\$i = 0; \$i <= \$page->last_item - \$page->first_item && \$page->total_items > 0; \$i++) { \x3f>
    <tr>
        <td class="nowrap"><a title="<\x3fphp printf(_("Edit %s"), oTxt(\$list[\$i]['______RECORD_NAME______'])) \x3f>" href="<\x3fphp echo ohref(\$_SERVER['PHP_SELF'] . '?op=edit&$primary_key=' . \$list[\$i]['$primary_key']); \x3f>"><img src="<\x3fphp echo \$CFG->admin_url; \x3f>/_widgets/edit.gif" alt="Edit" width="14" height="18" border="0"></a> &nbsp;</td>
        <td class="nowrap"><a title="<\x3fphp printf(_("Versions of %s"), oTxt(\$list[\$i]['______RECORD_NAME______'])) \x3f>" href="<\x3fphp echo ohref("\$CFG->admin_url/record_versions.php?record_table=$db_tbl&record_key=$primary_key&boomerang=true&record_val=" . \$list[\$i]['$primary_key']); \x3f>"><img src="<\x3fphp echo \$CFG->admin_url; \x3f>/_widgets/subcategory.gif" alt="" width="18" height="14" border="0" /></a> &nbsp;</td>

E_O_F;

// Print List rows.
if (!isset($op) || 'listrows' == $op) {
    foreach ($listrows as $col_data) {
?>
        <td class="nowrap"><?php echo $col_data; ?> &nbsp;</td>
<?php
    }
}

echo isset($op) ? '' : <<<E_O_F
        <td class="nowrap" align="right"><a title="<\x3fphp printf(_("Delete %s"), oTxt(\$list[\$i]['______RECORD_NAME______'])) \x3f>" href="<\x3fphp echo ohref(\$_SERVER['PHP_SELF'] . "?op=del&$primary_key=" . \$list[\$i]['$primary_key']); \x3f>" onclick="javascript:return confirm('<\x3fphp printf(_("Are you sure you want to delete the record %s? This action is permanent and cannot be undone."), oTxt(\$list[\$i]['______RECORD_NAME______'])) \x3f>')"><img src="<\x3fphp echo \$CFG->admin_url; \x3f>/_widgets/delete.gif" alt="Delete" width="16" height="17" border="0"></a> &nbsp;</td>
    </tr>
    <\x3fphp } \x3f>
</table>

<\x3fphp if (\$page->total_pages > 1) { \x3f>
<div class="nowrap commandtext" style="float: right;"><\x3fphp echo _("Pages:"); \x3f>&nbsp;<\x3fphp \$page->printPageNumbers() \x3f></div>
<\x3fphp } \x3f>
</form>

E_O_F;

?>